import App from './App'
import messages from './locale/index'

let i18nConfig = {
	locale: uni.getLocale(),
	messages
}

// #ifndef VUE3
import Vue from 'vue'
import VueI18n from 'vue-i18n'
Vue.use(VueI18n)
const i18n = new VueI18n(i18nConfig)
Vue.config.productionTip = false
App.mpType = 'app'
const app = new Vue({
	i18n,
	...App
})
app.$mount()
// #endif

// #ifdef VUE3
import {
	createSSRApp
} from 'vue'
import {
	createI18n
} from 'vue-i18n'
const i18n = createI18n(i18nConfig)
export function createApp() {
	const app = createSSRApp(App)
	app.use(i18n)
	return {
		app
	}
}
// #endif

import uView from '@/uni_modules/uview-ui'
Vue.use(uView)

import store from './store' // store
Vue.prototype.$store = store

import plugins from './plugins' // plugins
Vue.use(plugins)
import VueVirtualScroller from 'vue-virtual-scroller'

Vue.use(VueVirtualScroller)
// import moment from 'moment'
// Vue.prototype.$moment = moment

// import cuCustom from '@/colorui/components/cu-custom.vue'
// Vue.component('cu-custom',cuCustom)